/* SPDX-License-Identifier: GPL-2.0 */
/*
 * Header File for Altera SPI Driver.
 */
#ifndef __LINUX_NFB_SPI_ALTERA_H
#define __LINUX_NFB_SPI_ALTERA_H

#include <linux/version.h>

#include <config.h>

#if !defined(CONFIG_HAVE_SPI_INIT_HOST) && !defined(CONFIG_HAVE_SPI_INIT_MASTER)

#include <linux/interrupt.h>
#include <linux/regmap.h>
#include <linux/spi/spi.h>
#include <linux/types.h>

struct altera_spi {
	int irq;
	int len;
	int count;
	int bytes_per_word;
	u32 imr;

	/* data buffers */
	const unsigned char *tx;
	unsigned char *rx;

	struct regmap *regmap;
	u32 regoff;
	struct device *dev;
};

extern irqreturn_t altera_spi_irq(int irq, void *dev);
extern void altera_spi_init_host(struct spi_controller *host);
#else
#include <linux/spi/altera.h>
#endif
#endif /* __LINUX_NFB_SPI_ALTERA_H */
