#include <linux/module.h>
#include <linux/interrupt.h>
#include <linux/of.h>
#include <linux/platform_device.h>
#include <linux/spi/spi.h>
#include <linux/spi/spi_bitbang.h>
#include <linux/spi/xilinx_spi.h>
#include <linux/io.h>

#include <config.h>

struct nfb_device;

#ifdef CONFIG_HAVE_SPI_CONTROLLER
struct spi_controller *nfb_xilinx_spi_probe(struct nfb_device *nfb, int fdt_offset);
int nfb_xilinx_spi_remove(struct spi_controller *master);
#else
struct spi_master *nfb_xilinx_spi_probe(struct nfb_device *nfb, int fdt_offset);
int nfb_xilinx_spi_remove(struct spi_master *master);
#endif

void xilinx_spi_chipselect(struct spi_device *spi, int is_on);
int xilinx_spi_txrx_bufs(struct spi_device *spi, struct spi_transfer *t);
int xilinx_spi_txrx_bufs_continuous(struct spi_device *spi, struct spi_transfer *t);
